;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; filter.asm
;;
;; Copyright 1999 G. Adam Stanislav
;; All rights reserved
;;
;; Started: 17-Nov-1999
;; Updated: 17-Nov-1999
;;
;; This is a common entry point for all Red Prince Flips 'n Rolls
;; Adobe Photoshop filter plugins for Windows 95/98/NT.
;;
;; Requires NASM to assemble:
;;
;;	nasm -f win32 filter.asm
;;
;; If you don't have NASM, get it from ftp.whizkidtech.net/asm/
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

extern	filter.parameters
extern	filter.prepare
extern	filter.start
extern	filter.continue
extern	filter.finish
extern	filter.name

extern	__imp__MessageBoxA@16

section	.drectve	info
db	"-defaultlib:user32.lib "
db	"-entry:filterDLL "
db	"-DLL "
db	"-version:1.0 "
db	"-machine:i386 "
db	"-subsystem:windows,4.0 "
db	"-export:rpFilter "

section	.data
filter.author	db	"Copyright ", 169, " 1999, G. Adam Stanislav", 0Ah
	db	"All rights reserved.", 0Ah, 0Ah
	db	"http://www.redprince.net/", 0

section	.text align=4

align 4
global	_filterDLL@12
_filterDLL@12:

	mov	al, 1
	ret	12

align 4
filter.about:
	sub	eax, eax
	mov	ecx, dword [esp+8]	; address of hWnd
	push	eax
	push	dword filter.name
	push	dword filter.author
	jecxz	.@@
	mov	eax, [ecx]

.@@:
	push	eax
	call	dword [__imp__MessageBoxA@16]
	ret

align 4
calls	dd	filter.about
	dd	filter.parameters
	dd	filter.prepare
	dd	filter.start
	dd	filter.continue
	dd	filter.finish
numcalls	equ	($-calls)/4

align 4
global	rpFilter
rpFilter:

	; We receive four parameters:
	;
	;	[esp+ 4] = selector (word)
	;	[esp+ 8] = address of filterParamBlock
	;	[esp+12] = address of data
	;	[esp+16] = address of result word 

	mov	ecx, [esp+16]	; result
	jecxz	.error

	mov word [ecx], 0
	movzx	eax, word [esp+4]
	cmp	eax, numcalls
	jae	.unknown
	jmp	dword [calls+eax*4]

align 4
.unknown:
	mov	word [ecx], -30100

.error:
	ret
